/*
 * File: app/controller/Manager/Intention.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('installwiz.controller.Manager.Intention', {
	extend: 'Ext.app.Controller',

	refs: [
		{
			ref: 'Container',
			selector: '#mainView #container'
		},
		{
			ref: 'Discovery',
			selector: '#mainView #iframeDiscovery'
		},
		{
			ref: 'startButton',
			selector: '#mainView #body #bottomBar #startButton'
		},
		{
			ref: 'Topbar',
			selector: '#mainView #topbar'
		},
		{
			ref: 'ButtonBar',
			selector: '#mainView #buttonBar'
		},
		{
			ref: 'EulaPopup',
			selector: '#mainView #eulaPopup'
		}
	],

	/*
		@public
		Executed in the change of the eula checkbox, here is done updating the eula state
		@param {field} <Object> Object with de field struct
		@param {newValue} <Boolean> Boolean value
	*/
	onEulaCheckboxChange: function(field, newValue) {
		installwiz.model.Form.Observer.updateState("eula", newValue);
	},

	onStartButtonClick: function(button, e, eOpts) {
		this.changeButtonStartStatus(false);
		installwiz.app.getController("LoadMask").changeVisibility(true).updateMsg(Ext.locale.translate('Configuring application'));
		this.configureOpUser();
		installwiz.app.getController("ErrorHandler").showErrorBox(false);
	},

	onFinishButtonClick: function(button, e, eOpts) {
		this.exitApplication();
	},

	/*
		@public
		Create a click event on label
	*/
	onEulaLabelAfterRender: function(component, eOpts) {
		var me = this;

		component.el.dom.addEventListener("click", function(event) {
			if (me.isEulaTermLink(event.target)) {
				return me.openEulaTerm();
			}
			return installwiz.app.getController("Manager.State").toggleEulaTerm();
		});
	},

	onPanelBeforeClose: function(panel, eOpts) {
		this.openEulaTerm(false);
		return false;
	},

	onPopupEulaCheckboxChange: function(field, newValue, oldValue, eOpts) {
		installwiz.app.getController("Manager.State").changeEulaTerm(newValue);
		if (newValue === true) {
			this.openEulaTerm(false);
		}
	},

	/*
		@public
		Get password value using Maybe Type
		@return <String>
	*/
	getPasswordValue: function() {
		return this.getInputValue__("password");
	},

	/*
		@public
		Get repassword value using Maybe Type
		@return <String>
	*/
	getRepasswordValue: function() {
		return this.getInputValue__("repassword");
	},

	/*
		@public
		Get email value using Maybe Type
		@return <String>
	*/
	getEmailValue: function() {
		return this.getInputValue__("email");
	},

	/*
		@private
		Get password based on key
		@return key <String> The key can be password or repassword
	*/
	getInputValue__: function(key) {
		var ma =
			installwiz.Support.head(Ext.ComponentQuery.query("#mainView #body #userForm #" + key))
				.chain(function(o) {
					return installwiz.Support.prop("getValue") (o)
							.map(function(f) { return f.bind(o); });
				})
				.map(function(f) { return f(); });

		return installwiz.Maybe.withDefault("", ma);
	},

	/*
		@public
		Executed to change the state of the start button (enabling / disabling)
		@param {stats} <Bool> Boolean value
	*/
	changeButtonStartStatus: function(stats) {
		this.getStartButton().setDisabled(!stats);
		return this;
	},

	/*
		@public
		Executed when set to have user password changed
	*/
	configureOpUser: function() {
		var email = this.getEmailValue();
		var password = this.getPasswordValue();
		installwiz.app.getController("LoadMask").updateMsg(Ext.locale.translate('Configuring user'));
		installwiz.app.getController("Manager.UserOpmon").updateOpmonAdmin(email, password);
		return this;
	},

	/*
		@public
		Run when user configured to run discovery
	*/
	goToDiscovery: function() {
		var me = this;
		var loadMask = installwiz.app.getController("LoadMask");
		loadMask.updateMsg(Ext.locale.translate('Redirecting to discovery'));
		this.changeIframeSrc("/opmon/seagull/modules/discovery/templates/ext/app.php")
			.getDiscovery().el.dom.addEventListener("load", function() {
				me.changeView();
				loadMask.changeVisibility(false);
			});
		return this;
	},

	/*
		@public
		Run when user configured to run discovery
	*/
	showError: function(response) {
		var msg =
			installwiz.Maybe.withDefault
				( Ext.locale.translate('The settings could not be applied, please try again later.')
				, installwiz.Maybe.of(response.statusText)
				);
		this.changeButtonStartStatus(true);
		installwiz.app.getController("LoadMask").changeVisibility(false);
		installwiz.app.getController("ErrorHandler").trigger(msg);
		return this;
	},

	changeView: function() {
		this.getContainer().hide();
		this.getTopbar().hide();
		this.getButtonBar().show();
		this.getDiscovery().show();
		return this;
	},

	changeIframeSrc: function(src) {
		var me = this;
		me.getDiscovery().el.dom.style = "block";
		me.getDiscovery().el.dom.src = src;
		return me;
	},

	exitApplication: function() {
		window.location = "/opmon/seagull/www/index.php/opinterface/action/index/?initial_page=/opmon/seagull/modules/workspace/templates/homeDashboard/";
		return this;
	},

	isEulaTermLink: function(target) {
		return (target.id === "eulaterm");
	},

	openEulaTerm: function(value) {
		var fn = (value === true || value === null || value === undefined) ? "show" : "hide";
		this.getEulaPopup()[fn]();
		return this;
	},

	init: function(application) {
				var configuration = installwiz.app.getController("Manager.Configuration");
				var translate = installwiz.app.getController("Translate");

				configuration.onSuccess(this.goToDiscovery.bind(this));
				configuration.onFail(this.showError.bind(this));

				installwiz.app.getController("Manager.UserOpmon").onSuccess(configuration.configure.bind(configuration));
				installwiz.app.getController("Manager.UserOpmon").onFail(this.showError.bind(this));

				installwiz.app.getController("Manager.Configuration").onChangeLanguageDone(translate.setLanguageArray.bind(translate));

		this.control({
			"#mainView #body #userForm #eulaCheckbox": {
				change: this.onEulaCheckboxChange
			},
			"#startButton": {
				click: this.onStartButtonClick
			},
			"#go_to_status": {
				click: this.onFinishButtonClick
			},
			"#mainView #container #body #userForm #eulaContainer #eulaLabel": {
				afterrender: this.onEulaLabelAfterRender
			},
			"#mainView #eulaPopup": {
				beforeclose: this.onPanelBeforeClose
			},
			"#accept_checkbox": {
				change: this.onPopupEulaCheckboxChange
			}
		});
	}

});
