/*
 * File: app/controller/Translate.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('installwiz.controller.Translate', {
	extend: 'Ext.app.Controller',

	refs: [
		{
			ref: 'WelcomeMsg',
			selector: '#mainView #container #body #welcomeMsg #description'
		},
		{
			ref: 'EulaLabel',
			selector: '#mainView #container #body #userForm #eulaLabel'
		},
		/*{
			ref: 'AKeyLink',
			selector: '#mainView #container #body #userForm #getKey'
		}*/
	],

	onEulaLabelAfterRender: function(component, eOpts) {
		this.updateEulaLabel();
	},

	onContainerAfterRender: function(component, eOpts) {
		component.el.dom.addEventListener("click", function(event) {
			var flag = event.target.id;
			Ext.locale.lang = flag;
			if (flag === "pt_BR" || flag === "en_US") {
				installwiz.app.getController("Manager.Configuration").changeLanguage(event.target.id);
			}
		});
	},

	translateWelcomeMsg: function(version, text) {
		var component = this.getWelcomeMsg();

		component.update(
			(text || component.el.dom.innerHTML)
				.replace("%tag%", "<span>")
				.replace("%tagend%", "</span>")
				.replace("%version%", version ? version.split(/[-_]/)[0] : "")
				.replace("%link%", '<a href="http://kb.'+ this.getUrl() +'/knowledge-base/wizard/" target="_blank">')
				.replace("%endlink%", "</a>")
		);
	},
	/*
	translateLinkGetAnewKey: function(text) {
		var component = this.getAKeyLink();

		component.update(
			('<a href="https://www.'+ this.getUrl() +'/get_a_new_key/" target="_blank">')
				.concat(text || component.el.dom.innerHTML)
				.concat('</a>')
		);
	},
	*/
	getUrl: function() {
		var language = installwiz.app.getController("Translate").getLanguage();
		return (language === "pt_BR") ? "opservices.com.br" : "opservices.com";
	},

	getLanguage: function() {
		return Ext.locale.lang;
	},

	setLanguage: function(x) {
		installwiz.Maybe.of(x)
			.map(function(lang) { return (Ext.locale.lang = lang, x); });
		return this;
	},

	setLanguageArray: function(xs) {

		installwiz.Maybe.of(xs)
		.map(function(langs) { return (langArray = langs, langs); })
		.map(this.trigger__.bind(this));
		return this;
	},

	onChange: function(f) {
		this.observers.subscribe("change", f);
		return this;
	},

	trigger__: function(result) {
		this.observers.trigger("change", [result]);
		return this;
	},

	updateEulaLabel: function(text) {
		this.getEulaLabel().el.dom.innerHTML =
			(text || this.getEulaLabel().el.dom.innerHTML)
				.replace("%link%", '<span id="eulaterm" class="eulalink">')
				.replace("%endlink%", '</span>');
	},

	init: function(application) {
				this.observers =
				new OPObserver(["change"]);

		this.control({
			"#eulaLabel": {
				afterrender: this.onEulaLabelAfterRender
			},
			"#mainView #topbar #flags": {
				afterrender: this.onContainerAfterRender
			}
		});
	}

});
