/*
 * File: app/view/FailPopUp.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('installwiz.view.FailPopUp', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.view.View',
		'Ext.XTemplate',
		'Ext.button.Button',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer'
	],

	autoShow: true,
	id: 'fail_popup',
	width: 400,
	closable: false,
	header: false,
	title: 'My Window',
	modal: true,

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					html: '<h2 class=\'popup-title\' style=\'margin:0;\'>Algumas configurações não puderam ser aplicadas.<br>Verifique abaixo.</h2>',
					id: 'header',
					padding: '30 30 0',
					listeners: {
						beforerender: {
							fn: me.onHeaderBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'container',
					id: 'content',
					margin: '0 0 20',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'dataview',
							id: 'return_list',
							padding: '0 35 0 30',
							itemSelector: 'div',
							itemTpl: [
								'<tpl>',
								'	<h3 style="padding-top:10px;">{group_name}</h3>',
								'	<ul style="list-style:none; padding-left: 10px;" class="error_list">',
								'    <tpl>',
								'        <li>',
								'            <p style="line-height:1.5;">',
								'                <span style="font-style:italic; color: #ff0000;">{message}</span>',
								'            </p>',
								'        </li>',
								'    </tpl>',
								'    </ul>',
								'</tpl>'
							],
							store: 'errors'
						},
						{
							xtype: 'container',
							flex: 1,
							id: 'end_process',
							padding: '18 32 0',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'button',
									flex: 1,
									height: 30,
									id: 'change_o_default_btn',
									text: 'Alterar para configurações padrão e prosseguir',
									listeners: {
										click: {
											fn: me.onChange_o_default_btnClick,
											scope: me
										},
										beforerender: {
											fn: me.onBtnChangeBeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					id: 'nav',
					items: [
						{
							xtype: 'button',
							id: 'edit_btn',
							text: 'Editar configurações',
							listeners: {
								click: {
									fn: me.onEdit_btnClick,
									scope: me
								},
								beforerender: {
									fn: me.onBtnEditBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'button',
							id: 'try_btn',
							text: 'Tentar novamente',
							listeners: {
								click: {
									fn: me.onTry_btnClick,
									scope: me
								},
								beforerender: {
									fn: me.onBtnTryBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onHeaderBeforeRender: function(component, eOpts) {
		component.update(
			l[language_id]['<h2 class=\'popup-title\' style=\'margin:0;\'>Some settings could not be applied.<br>Check below.</h2>'] ||
			'<h2 class=\'popup-title\' style=\'margin:0;\'>Algumas configurações não puderam ser aplicadas.<br>Verifique abaixo.</h2>'
		);
	},

	onChange_o_default_btnClick: function(button, e, eOpts) {
		var eula = Ext.getCmp('eulaView');
		eula.backToDefaultBackupConfiguration();
		eula.backToDefaultNTPConfiguration();
		eula.backToDefaultServerConfiguration();
		eula.backToDefaultMailConfiguration();
		eula.doConfiguration();
		this.destroy();
	},

	onBtnChangeBeforeRender: function(component, eOpts) {
		component.setText(l[language_id]['Change to default and continue'] || 'Alterar para configurações padrão e prosseguir');
	},

	onEdit_btnClick: function(button, e, eOpts) {
		this.destroy();
	},

	onBtnEditBeforeRender: function(component, eOpts) {
		component.setText(l[language_id]['Edit settings'] || 'Editar configurações');
	},

	onTry_btnClick: function(button, e, eOpts) {
		Ext.getCmp('eulaView').doConfiguration();
		this.destroy();
	},

	onBtnTryBeforeRender: function(component, eOpts) {
		component.setText(l[language_id]['Try again'] || 'Tentar novamente');
	}

});